#! /bin/sh
eval '(exit $?0)' && eval 'PERL_BADLANG=x;PATH="$PATH:.";export PERL_BADLANG\
;exec perl -x -S -- "$0" ${1+"$@"};#'if 0;eval 'setenv PERL_BADLANG x\
;setenv PATH "$PATH":.;exec perl -x -S -- "$0" $argv:q;#'.q
#!perl -w
+push@INC,'.';$0=~/(.*)/s;do(index($1,"/")<0?"./$1":$1);die$@if$@__END__+if 0
;#Don't touch/remove lines 1--7: http://www.inf.bme.hu/~pts/Magic.Perl.Header
#
# mpgsmap.pl -- create Ghostscript font map from a .mp file
# by pts@fazekas.hu at Sun Oct 12 23:45:07 CEST 2003
# -- Mon Oct 13 00:36:57 CEST 2003
# support for bitmap fonts and ReEncodeFont at Fri Mar 19 13:41:31 CET 2004
#
# Dat: to be used with \usepackage[fixfshow=in-mps]{eempost}
# Imp: load Fontmap.GS -- but it shouldn't override our fonts!
# Imp: move %%HiResBoundingBox earlier
# Imp: Win32: binmode + etc.
#

use integer;
use strict;

#** -1: do fix /fshow
#** 0: don't fix /fshow, not required yet
#** >=1: don't fix /fshow, but required in this many files
my $fix_o=-1;
#** ./Fontmap for gs >=6.70
my $Fontmap='Fontmap';
#** -Pdfp: compatibility with dff.pl (already run)
my @dvipsopts=(-f 'config.dfp') ? ('-Pdfp') : ();
my $opt_fontembed=0;

{ my $I;
  for ($I=0;$I<@ARGV;$I++) {
    if ($ARGV[$I] eq'--') { $I++; last }
    elsif ($ARGV[$I] eq'--fix') { $fix_o=-1 } # fix
    elsif ($ARGV[$I] eq'--fix=0') { $fix_o=0 } # don't fix
    elsif ($ARGV[$I] eq'--fontembed') { $fix_o=-1; $opt_fontembed=1 }
    elsif ($ARGV[$I] eq'--dvips0') { @dvipsopts=() }
    elsif ($ARGV[$I] eq'--help') { $I=scalar@ARGV; last }
    elsif ($ARGV[$I] eq'-o' and $I<$#ARGV) { $Fontmap=$ARGV[++$I] }
    elsif ($ARGV[$I] eq'--dvipsopt' and $I<$#ARGV) { push @dvipsopts, $ARGV[++$I] }
    elsif (substr($ARGV[$I],0,1) ne '-') { last }
    else { die "$0: invalid option: $ARGV[$I]\n" }
  }
  splice @ARGV, 0, $I;
}

die "mpgsmap.pl: MetaPost font fixer for Ghostscript
Written and (C) by <pts\@fazekas.hu> from October 2003. GNU GPL. NO WARRANTY.

Usage: $0 [--fix] [-o <Fontmap>] <jobname>{[.mp]|.dvi} ...
Options:
--fix        (default) modify EPS files emitted by MetaPost
--fix=0      don't modify EPS files, emit a warning if this would cause harm
--fontembed  embed fonts directly to each EPS figure (and don't create Fontmap)
--dvips0     clear --dvipsopt list
--dvipsopt O add option O to the list of options passed to dvips
--help       this message
-o F         create Fontmap in file F (no effect with --fontembed)
" if !@ARGV;
# ---

#** @param $_[0] DVI file name
#** @return () or (WD,HT) from \special{papersize=WD,HT}
#** ripped from dff.pl get_dvi_papersize
sub get_dvi_psfiles($) {
  die "$0: DVI not found: $_[0]\n" if! open DVIF, "< $_[0]";
  my $head;
  if (15!=read DVIF, $head, 15) { IOerr: #close DVIF;
    die "$0: syntax error in DVI file, offset ".tell(DVIF).": $_[0]\n"
  }
  # ($dummy,$bbi->{'Info.version_id'},$bbi->{'Info.numerator'}, $bbi->{'Info.denominator'},$bbi->{'Info.magnification'})=unpack('CCNNN',$head);
  my $dummy=vec($head,14,8);
  my $bbi_jobname; # unused
  my $bbi_page1_nr;
  goto IOerr if $dummy!=read DVIF, $bbi_jobname, $dummy;
  my($tag,$action);
  my @actions=(0)x256; # skip that char
  $actions[139]=15; # Bop
  # vvv Dat: 223 is TRAILER, but also FONT_52
  @actions[248,249]=(16,16,16,16); # stop parsing file (postamble, postpost)
  # @actions[140]=(16); # Dat: don't stop at 1st EOP
  @actions[128,133,143,148,153,157,162,167,235]=(1,1,1,1,1,1,1,1,1); # read 1 extra bytes
  @actions[129,134,144,149,154,158,163,168,236]=(2,2,2,2,2,2,2,2,2); # read 2 extra bytes
  @actions[130,135,145,150,155,159,164,169,237]=(3,3,3,3,3,3,3,3,3); # read 2 extra bytes
  @actions[131,136,146,151,156,160,165,170,238]=(4,4,4,4,4,4,4,4,4); # read 2 extra bytes
  @actions[132,137]=(8,8); # read 8 extra bytes
  @actions[243,244,245,246]=(17,18,19,20); # Fnt_def
  @actions[239,240,241,242]=(33,34,35,26); # Special (XXX)
  my %H;
  while (1) {
    #info tell DVIF;
    goto IOerr if !defined($tag=getc(DVIF)); # Dat: EOF is error
    #info ord $tag;
    $tag=$actions[ord($tag)];
    if ($tag==0) {
    } elsif ($tag==16) {
      last
    } elsif ($tag==15) { # Bop
      goto IOerr if 44!=read DVIF, $dummy, 44;
      if (!defined $bbi_page1_nr) {
        $bbi_page1_nr=unpack "N", $dummy;
      }
    } else {
      # read number of ($tag&15) bytes in MSBfirst byte order
      $dummy="\0\0\0\0";
      goto IOerr if ($tag&15)!=read DVIF, $dummy, ($tag&15), 4;
      $dummy=unpack("N",substr($dummy,-4));
      if ($tag>=33) { # Special
        goto IOerr if $dummy!=read DVIF, $tag, $dummy;
        $tag=~s@\s+\Z(?!\n)@@;
	# info "DVI \\special ($tag)";
	#if ($tag=~m@\Apapersize\s*=\s*(\S+)\s*,\s*(\S+)\s*\Z(?!\n)@) {
	#  info "overriding papersize=" if @L;
	#  @L=($1,$2)
	if ($tag=~m@\A\s*psfile\s*=\s*"([^"]+)"@i) { # Dat: may contain llx= etc.
	  $H{$1}=1;
	}
	# info tell DVIF;
        # if ($L[0] eq 'landscape') # Imp: set papersize=11in,8.5in with low prio?
      } elsif ($tag>=17) { # Fnt_def
        goto IOerr if 14!=read DVIF, $tag, 14;
        $dummy=vec($tag,12,8)+vec($tag,13,8);
        goto IOerr if $dummy!=read DVIF, $tag, $dummy;
      }
    } # IF 
  } # WHILE
  close DVIF;
  sort keys %H # no useful \special found (); or (width,height)
}

my @exts=();
for my $mp (@ARGV) {
  $mp.='.mp' if $mp!~m@[.][^\\/.]+\Z(?!\n)@;
  die "$0: input file not found: $mp: $!\n" if !open MP, "< $mp";
  my $got_endfig=0;
  my $magic; die unless read MP, $magic, 2;
  if ($magic eq '%!') { # PostScript
    # die "$0: cannot read PostScript file. Give me MetaPost _input_!\n";
    push @exts, $mp;
  } elsif ($magic eq '%P') { # %PDF-1.
    die "$0: I don't known how to read PDF files\n";
  } elsif ($magic eq "\367\002") { # DVI
    # Dat: a little slow, but works fine
    push @exts, get_dvi_psfiles $mp;
  } else { # assume MetaPost source file
    my $jobname=$mp; $jobname=~s@[.][^\\/.]+\Z(?!\n)@@;
    while (<MP>) {
      if (0!=length $magic) { $_=$magic.$_; $magic="" }
      s@(?:%.*|"[^"]*")@@g; # remove comments and strings
      if (/\bbeginfig\s*\(\s*(-?\d+)\s*\)/) { push @exts, $jobname.($1<0 ? ".ps" : ".$1") }
      $got_endfig=1 if !/\bendfig\b/;
    }
    die "$0: missing beginfig from .mp: $mp\n" unless @exts;
    die "$0: missing endfig from .mp: $mp\n" unless $got_endfig;
  }
  die "$!" unless close MP;
}

#** $fix_epss{'jobname.42'}="  /cmr10 ...\n/fshow ...\n";
my %fix_epss;

#** key is TeX font name, value is either undef (PS font name unknown) or
#** a string containing the PS font name (may be equal to the TeX font name
my %fontname2ps;
my %fontdesignsize; # $fontdesignsize{cmr7}='6.97385';
my %fix_epsfso; # $fix_epsfo{"foo.1"}=file_offset of\ start of /fshow line
my %fix_epsfembed; # $fix_epsfo{"foo.1"}=1;
for my $ext (@exts) { # Dat: $ext is now a full filename
  if (open EPS, "< $ext") {
    my $had_df=0;
    my $had_df2=0;
    my $had_epsf_start=-1;
    my $had_bbox_late=0;
    my %thisfontname2ps;
    my %psfontmissing;
    while (<EPS>) {
      if (substr($_,0,1)ne'%') {
        if ($had_df and m@^ */([^ /]+) /([^ /]+) def$@) {
	  # Dat: prologues:=1 font definition, just after %%DocumentFonts
	  print STDERR "warning: ambigious PS name for $1: $2\n" if
	    defined $fontname2ps{$1} and $fontname2ps{$1} ne $2;
	  $thisfontname2ps{$1}=$fontname2ps{$1}=$2;
	  ##print STDERR "@{[%psfontmissing]};a($2)\n";
	  delete $psfontmissing{$2};
	  ##print STDERR "@{[%psfontmissing]};b\n";
	  next
	}
        if (($opt_fontembed or !m@^/fshow@) and %thisfontname2ps) {
	  # ^^^ Imp: add these lines to EPS if missing:
	  #     /fshow where{pop}{/fshow{exch findfont exch scalefont setfont show}bind def}ifelse
	  #     /rpxpplr dup where{pop pop}{dup def}ifelse
	  #     /rpxpplri dup where{pop pop}{dup def}ifelse
	  #     /cmmi10 dup where{pop pop}{dup def}ifelse
	  if ($fix_o>=0) {
	    print STDERR "warning: definition of /fshow is missing in ($.): $ext\n";
	    $fix_o++;
	  } elsif ($fix_o<0) {
	    my $S="%%DocumentFonts: \n"; # Dat: make idempotent
	    while (my($texfontname,$psfontname)=each%fontname2ps) {
	      # Dat: mpost(1) `prologues:=1' adds ` /cmtt10 /CMTT10 def',
	      #      we add `  /cmtt10 /cmtt10 def'
	      $S.="  /$texfontname /".(defined$psfontname ? $psfontname : $texfontname)." def\n";
	    }
	    $S.="/fshow where{pop}{/fshow{exch findfont exch scalefont setfont show}bind def}ifelse\n";
	    $fix_epss{$ext}=$S;
	    $fix_epsfso{$ext}=tell(EPS)-length if substr($_,0,6)eq'/fshow';
	    die "$0: not enough font information; use prologues:=0;\n" if $had_df2;
	    # ^^^ Dat: we don't know the font design size and the used sizes. Too bad. And we also don't know the TeX font names.
	    $fix_epsfembed{$ext}=1 if $opt_fontembed;
	  }
	} elsif (!$had_epsf_start) {
	  if ($fix_o>=0) {
	    print STDERR "warning: missing EPSF- comment: $ext\n";
	    $fix_o++;
	  } else {
  	    $fix_epss{$ext}=""; # fix only EPSF heading comment
	  }
	} elsif (($had_bbox_late&3)==3) { # Imp: not elsif
	  if ($fix_o>=0) {
	    print STDERR "warning: bbox too late: $ext\n";
	    $fix_o++;
	  } else {
  	    $fix_epss{$ext}=""; # fix only EPSF heading comment
	  }
	}
	last
      }
      if ($had_epsf_start<0) {
        $had_epsf_start=/^%!PS-Adobe-\d+[.]\d+ +EPSF-\d+[.]\d+/;
      }
      if (/^%[*]Font: +(\S+) +(\S+) +(\S+)/) { # by prologues:=0; %*Font: cmsl10 9.96265 9.96265 61:8100128
        # Dat: multiple %*Font comments are possible for different _use_ sizes
	$thisfontname2ps{$1}=$fontname2ps{$1}=undef;
	# !! remember used-character-bits here
	$fontdesignsize{$1}=$3;
      } elsif (/^%%DocumentFonts: +(.*)/ or ($had_df and /^%%[+] +(.*)/)) {
	for my $fn (split' ',$1) { $psfontmissing{$fn}=1; $had_df2=1 }
        $had_df=1; next
      } elsif (/^%%EndProlog\b/) { $had_bbox_late|=1 } # !! also EndComments
      elsif (/^%%(?:HiRes|Exact|)BoundingBox:/) { $had_bbox_late|=2 if $had_bbox_late&1 }
      $had_df=0;
    }
    close EPS;
    if (%psfontmissing) {
      print STDERR "warning: undefined PS fonts: @{[keys%psfontmissing]}\n";
      # Dat: don't include these into %fontname2ps
    }
  } else { print STDERR "warning: mpost hasn't been run on: $ext\n" }
}
if ($fix_o>0) {	  
  print STDERR "warning: to make fonts come out right, run me with --fix\n";
}

sub shq($) {
  return $_[0] if $_[0]=~m@\A[-_./A-Za-z0-9]+\Z(?!\n)@;
  my $S=$_[0]; $S=~s@'@'\\''@g; "'$S'"
}

my $t3_texdict='303 dict begin % modified TeXdict (original in texc.pro)
/N{def}def/B{bind def}N/S{exch}N/X{S
N}B/A{dup}B/TR{translate}N/isls false N/vsize 11 72 mul N/hsize 8.5 72
mul N/landplus90{false}def/@rigin{isls{[0 landplus90{1 -1}{-1 1}ifelse 0
0 0]concat}if 72 Resolution div 72 VResolution div neg scale isls{
landplus90{VResolution 72 div vsize mul 0 exch}{Resolution -72 div hsize
mul 0}ifelse TR}if Resolution VResolution vsize -72 div 1 add mul TR[
matrix currentmatrix{A A round sub abs 0.00001 lt{round}if}forall round
exch round exch]setmatrix}N/@landscape{/isls true N}B/@manualfeed{
statusdict/manualfeed true put}B/@copies{/#copies X}B
/FMat matrix N % Dat: will be overridden later
/FBB[0 0 0 0]N/nn 0 N/IEn 0 N/ctr 0 N/df-tail{/nn 8 dict N nn begin
/FontType 3 N/FontMatrix fntrx N/FontBBox FBB N string/base X array
/BitMaps X
% vvv Dat: makes the font unprintable
/BuildChar[currentdict end currentdict exch begin % TeXDict
 /begin load /CharBuilder cvx /end load]cvx N% !!
%/BuildChar{CharBuilder}def
/Encoding IEn N end A{/foo setfont}2
array copy cvx N load 0 nn put/ctr 0 N[}B/sf 0 N/df{/sf 1 N/fntrx FMat N
df-tail}B/dfs{div/sf X

/fntrx[sf 0 0 sf neg neg 0 0]N% neg neg !!
df-tail}B
/E{}B % Dat: for compatibility
/EE{/EFN exch def pop nn A dup /FontName EFN put  exch pop EFN exch % ! E -> EE
definefont setfont}B
/Cw{Cd A length 5 sub get}B/Ch{Cd A length 4 sub get
}B/Cx{128 Cd A length 3 sub get sub}B/Cy{Cd A length 2 sub get 127 sub}
B/Cdx{Cd A length 1 sub get}B/Ci{Cd A type/stringtype ne{ctr get/ctr ctr
1 add N}if}B/id 0 N/rw 0 N/rc 0 N/gp 0 N/cp 0 N/G 0 N/CharBuilder{save 3
1 roll S A/base get 2 index get S/BitMaps get S get/Cd X pop/ctr 0 N Cdx
0 Cx Cy Ch sub Cx Cw add Cy setcachedevice Cw Ch true[1 0 0 -1 -.1 Cx
sub Cy .1 sub]/id Ci N/rw Cw 7 add 8 idiv string N/rc 0 N/gp 0 N/cp 0 N{
rc 0 ne{rc 1 sub/rc X rw}{G}ifelse}imagemask restore}B/G{{id gp get/gp
gp 1 add N A 18 mod S 18 idiv pl S get exec}loop}B/adv{cp add/cp X}B
/chg{rw cp id gp 4 index getinterval putinterval A gp add/gp X adv}B/nd{
/cp 0 N rw exit}B/lsh{rw cp 2 copy get A 0 eq{pop 1}{A 255 eq{pop 254}{
A A add 255 and S 1 and or}ifelse}ifelse put 1 adv}B/rsh{rw cp 2 copy
get A 0 eq{pop 128}{A 255 eq{pop 127}{A 2 idiv S 128 and or}ifelse}
ifelse put 1 adv}B/clr{rw cp 2 index string putinterval adv}B/set{rw cp
fillstr 0 4 index getinterval putinterval adv}B/fillstr 18 string 0 1 17
{2 copy 255 put pop}for N/pl[{adv 1 chg}{adv 1 chg nd}{1 add chg}{1 add
chg nd}{adv lsh}{adv lsh nd}{adv rsh}{adv rsh nd}{1 add adv}{/rc X nd}{
1 add set}{1 add clr}{adv 2 chg}{adv 2 chg nd}{pop nd}]A{bind pop}
forall N/D{/cc X A type/stringtype ne{]}if nn/base get cc ctr put nn
/BitMaps get S ctr S sf 1 ne{A A length 1 sub A 2 index S get sf div put
}if put/ctr ctr 1 add N}B/I{cc 1 add D}B/bop{userdict/bop-hook known{
bop-hook}if/SI save N @rigin 0 0 moveto/V matrix currentmatrix A 1 get A
mul exch 0 get A mul add .99 lt{/QV}{/RV}ifelse load def pop pop}N/eop{
SI restore userdict/eop-hook known{eop-hook}if showpage}N/@start{
userdict/start-hook known{start-hook}if pop/VResolution X/Resolution X
1000 div/DVImag X/IEn 256 array N 2 string 0 1 255{IEn S A 360 add 36 4
index cvrs cvn put}for pop 65781.76 div/vsize X 65781.76 div/hsize X}N
/p{show}N/RMat[1 0 0 -1 0 0]N/BDot 260 string N/Rx 0 N/Ry 0 N/V{}B/RV/v{
/Ry X/Rx X V}B statusdict begin/product where{pop false[(Display)(NeXT)
(LaserWriter 16/600)]{A length product length le{A length product exch 0
exch getinterval eq{pop true exit}if}{pop}ifelse}forall}{false}ifelse
end{{gsave TR -.1 .1 TR 1 1 scale Rx Ry false RMat{BDot}imagemask
grestore}}{{gsave TR -.1 .1 TR Rx Ry scale 1 1 false RMat{BDot}
imagemask grestore}}ifelse B/QV{gsave newpath transform round exch round
exch itransform moveto Rx 0 rlineto 0 Ry neg rlineto Rx neg 0 rlineto
fill grestore}B/a{moveto}B/delta 0 N/tail{A/delta X 0 rmoveto}B/M{S p
delta add tail}B/b{S p tail}B/c{-4 M}B/d{-3 M}B/e{-2 M}B/f{-1 M}B/g{0 M}
B/h{1 M}B/i{2 M}B/j{3 M}B/k{4 M}B/w{0 rmoveto}B/l{p -4 w}B/m{p -3 w}B/n{
p -2 w}B/o{p -1 w}B/q{p 1 w}B/r{p 2 w}B/s{p 3 w}B/t{p 4 w}B/x{0 S
rmoveto}B/y{3 2 roll p a}B/bos{/SS save N}B/eos{SS restore}B
31326618 44271121 1000 600 600 (mpgsmap_.dvi) @start 
';

my $t1_modifydict='16 dict begin
/SlantFont{ % <FontDict> <slant-mul> SlantFont <FontDict>
  %/FontMatrix [0.001 0 0.000167 0.001 0 0] def % .167 SlantFont
  1 index /FontMatrix0get get mul
  1 index /FontMatrix get 2 get add
  1 index /FontMatrix get exch 2 exch put
}bind def
/ExtendFont{ % <FontDict> <extend-mul> ExtendFont <FontDict>
  %/FontMatrix [0.0012 0 0 0.001 0 0] def % 1.2 ExtendFont
  1 index /FontMatrix0get get mul
  1 index /FontMatrix get exch 0 exch put
}bind def
/ReEncodeFont{ % <FontDict> <new-Encoding-Vector> ReEncodeFont <FontDict>
  %/FontMatrix [0.0012 0 0 0.001 0 0] def % 1.2 ExtendFont
  exch begin
  CharStrings rcheck{
    % vvv change all missing glyphs to /.notdef in the Encoding
    [exch{dup CharStrings exch known not{pop/.notdef}if}forall]
  }if
  /Encoding exch def
  currentdict end
}bind def
/changeFont{% <TargetFontName> <Action> <SourceFontName> changeFont -
  % Dat: gs allows <TargetFontName> == <SourceFontName> with definefont
  findfont
  % vvv Copy original font dictionary
  dup length dict begin
  { 1 index /FID ne 2 index /UniqueID ne and
    {def}{pop pop}ifelse
  } forall
  /FontMatrix FontMatrix dup length array copy def % make it writable
  /FontMatrix0get FontMatrix 0 get def % to make order of SlantFont and ExtendFont irrelevant
  % ^^^ Dat: also disallows multiple ExtendFont
  currentdict end
  exch exec % <Action>
  % Dat: stack: <TargetFontName> <FontDict>
  definefont pop % Dat: gs allows definefont to override
} bind def % Dat: bind is very important here (doesn\'t affect ReEncodeFont etc.)

';

#** @param $_[0] EPS filename to include
sub dvifile($) {
  # perl -p -e 's@[^-_.=/\w ]@sprintf("\\%03o",ord$&)@ge' <tac.dvi >tac.dvi.pl
  die "$0: file name too long: $_[0]\n" if length($_[0])>255-9;
  my $S=
  "\367\002\001\203\222\300\034\073\000\000\000\000\003\350\033 TeX output 2004.03.19\0721300\213\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\377\377\377\377\357".
  chr(9+length$_[0])."PSFile=\042$_[0]\042\214";
  my $PO=length$S;
  $S.="\370\000\000\000\052\001\203\222\300\034\073\000\000\000\000\003\350\000\000\000\000\000\000\000\000\000\000\000\001\371".pack("N",$PO)."\002";
  $S."\337"x(8-length($S)%8) # trailer: length%8==0
#  "\367\002\001\203\222\300\034\073\000\000\000\000\003\350\033 TeX output 2004.03.19\0721300\213\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\377\377\377\377\357\046PSFile".
#  " "x(29-length$_[0])."=\042$_[0]\042".
#  "\214\370\000\000\000\052\001\203\222\300\034\073\000\000\000\000\003\350\000\000\000\000\000\000\000\000\000\000\000\001\371\000\000\000\200\002\337\337\337\337\337"
}

my $pwd;
sub first_two { @_>1 ? "$_[0]  $_[1]" : @_ ? "$_[0]" : "" }
#** `undef $pwd;' must be called after chdir
#** ripped from cvss.pl
sub get_pwd() {
  return $pwd if defined $pwd;
  $pwd=qx(pwd); # No getcwd() as Perl builtin :-(, have to call /bin/pwd
  # ^^^ Dat: UNIX-specific
  chomp $pwd;
  $pwd=~s@//+@/@g;
  $pwd=~s@/+\Z(?!\n)@@ if $pwd ne '/';
  die "$0: wrong pwd: $pwd\n" if substr($pwd,-2) eq '/.' or
    substr($pwd,-3) eq '/..' or -1!=index($pwd,'/./') or
    -1!=index($pwd,'/../') or substr($pwd,0,1) ne '/' or
    first_two(lstat($pwd)) ne first_two(lstat('.'));
  $pwd
}

my $had_dvips=0;
#** @return 0 on success;
sub run_dvips {
  if (!$had_dvips) {
    my $tph=qx(kpsewhich --expand-var=\\\$TEXPSHEADERS 2>/dev/null); chomp $tph;
    ## die $tph; # {/home/guests/pts/texmf,/usr/local/share/texmf,/usr/local/lib/texmf,!!/usr/share/texmf}/{dvips,pdftex,tex,fonts/type1}//
    die "$0: missing \$TEXPSHEADERS" if 0==length$tph;
    $ENV{TEXPSHEADERS}=$tph=".:$tph" if substr($tph,0,2)ne'.:';
    $had_dvips=1;
  }
  print STDERR "mpgsmap info: running: dvips @_\n";
  # Imp: smart report error: if dvips prints: `! error while unpacking; more bits than required', this means that `infont' is using virtual fonts
  return system 'dvips', @_;
}  
  

# ---

my $genmsg="%% generated by $0 at ".scalar(localtime)."\n";
if (!$opt_fontembed) {
  die "$0: open4write $Fontmap: $!\n" if !open FONTMAP, "> $Fontmap";
  print FONTMAP "%% Ghostscript Fontmap for MetaPost images: @ARGV\n$genmsg";
}
if (!$opt_fontembed) {
my $C=0;
my $fontprefix='mpgsmap-'; # mpgsmap-cmr7.gsf etc.
if (%fontname2ps) {
  # Imp: win32
  my $mapname=(-f 'dff_ps.map') ? 'dff_ps.map'
             :(-f 'dff_t.map' ) ? 'dff_t.map' : 'pdftex.map';
  my $xmap=qx{kpsewhich --progname= "--format=other text files" $mapname 2>/dev/null}; chomp $xmap;
  die "$0: pdftex.map: not found\n" if 0==length $xmap;
  die "$0: open $xmap: $!\n" if !open XMAP, "< $xmap";
  my %fontmissing=map {$_=>1} keys %fontname2ps;
  my %fontnames2=%fontmissing;
  my %searchfiles;
  my %fontextras;
  my %fontchanges; # $fontchanges{'uplr8a.pfb'}='TeXBase1Encoding ReEncodeFont';
  my %fontextrafiles; $fontextrafiles{'uplr8a.pfb'}=['<tx8r.enc'];
  while (<XMAP>) { # Dat: dvips-pdftex (not dvipdfm) style config file
    ##print;
    if (s/^\s*((\w\S*)\s+.*)<([^\s'"]+.pf[ab])$/$1/i and exists $fontmissing{$2}) {
      my($texfontname,$psfontfile)=($2,$3);
      my $extras="";
      if (s@"([^"]*)"@@) {
        $extras=" $1 "; # "1.2 ExtendFont .167 SlantFont TeXBase1Encoding ReEncodeFont"
	$extras=~s@\s+@ @;
	$fontchanges{$texfontname}=substr($extras,1,length($extras)-2);
	#( enccorklm ReEncodeFont  )
	$extras=~s@ *(?:[-?[0-9.]+ (?:Slant|Extend)Font|\S+ ReEncodeFont) @@g;
	# Imp: check that <X.enc and ReEncodeFont are both present
	my $L=$fontextrafiles{$texfontname}=[];
	while (m@<(\S+)@g) { push @$L, $1; $searchfiles{$1}=1 }
      }
      $extras=~s@\s+@@;
      if ($extras!~/\S/) { # Dat: became $extras eq' ' for lmodern fonts
        ##print STDERR "($2 $3)\n";
        delete $fontmissing{$texfontname}; # Dat: former entry takes precedence
        # ^^^ Dat: don't use it if any of ReEncodeFont, SlantFont, ExtendFont etc. is present
        $searchfiles{$psfontfile}=1;
        $fontnames2{$texfontname}=$psfontfile;
      }
    }
  }
  die unless close XMAP;
  my %fontfull;
  if (%fontmissing and !$opt_fontembed) { # bitmap fonts left -- call dvips(1)
    # Dat: virtual fonts are already resolved by btex..etec
    # Dat: even dvips(1) won't run `TeXBase1Encoding ReEncodeFont' for us
    my $jobname='mpgsmap_';
    unlink "$jobname.eps", "$jobname.dvi", "$jobname.ps", "$jobname.log";
    die unless open F, "> $jobname.dvi";
    die unless print F dvifile("$jobname.eps");
    die unless close F;
    die unless open F, "> $jobname.eps";
    my $suffix=" 00:".("f"x 64)."\n";
    # ^^^ Dat: dvips(1) will emit a harmless `dvips: Design size mismatch in font cmr7' here
    die unless print F map {
      die "$0: design size not defined: $_\n" if !defined $fontdesignsize{$_};
      "%*Font: $_ $fontdesignsize{$_} $fontdesignsize{$_}$suffix"
    } keys %fontmissing;
    # ^^^ Imp: use only really used chars (instead of all `f's)
    die unless close F;
    unlink "$jobname.ps", "$jobname.log";
    # vvv Dat: `-j0' has effect only on Type1 fonts :-(
    die "$0: error running dvips(1) (fonts ".join(" ",keys%fontmissing).")\n".
      "  Please fix it and try again.\n" unless 0==run_dvips(@dvipsopts, '-j0', $jobname);
    die unless open PS, "< $jobname.ps";
    my $curtexfont;
    my $PWD=get_pwd();
    die "$0: cannot determine current dir\n" if 0==length($pwd) or !(-d $pwd);
    # !! check design size
    # !! check resolution
    # Dat: bitmap fonts are rendered in the default resolution. So magnifying
    #      them may lead to rough glyphs.
    while (<PS>) { # search for bitmap fonts
      if (!defined $curtexfont) {
        if (/^%DVIPSBitmapFont:\s+\S+\s+(\S+)/ and exists $fontmissing{$1}) {
	  # print STDERR "mpgsmap info: bitmap font: $_";
	  $curtexfont=$1;
	  die unless open F, "> $fontprefix$curtexfont.gsf";
	  print STDERR "mpgsmap info: creating $fontprefix$curtexfont.gsf\n";
	  die unless print F "%% a Ghostscript Type3 bitmap font of TeX font $curtexfont\n$genmsg$t3_texdict".
	        "/EDMUL 1 $fontdesignsize{$curtexfont} Resolution mul 72 div div def\n/FMat [EDMUL 0 0 EDMUL 0 0] def\n";
	} elsif (/^%%EndProlog/) { last }
      } else {
        if (/^%EndDVIPSBitmapFont$/) {
	 die unless print F "/$curtexfont EE end\n";
	 die unless close F;
	 $fontfull{$curtexfont}="$pwd/$fontprefix$curtexfont.gsf";
	 $fontnames2{$curtexfont}=$curtexfont;
	 delete $fontmissing{$curtexfont};
	 undef $curtexfont;
       }
	else { die unless print F $_ }
      }
    }
    die if defined $curtexfont;
    unlink "$jobname.eps", "$jobname.dvi", "$jobname.ps", "$jobname.log";
    print STDERR "warning: missing fonts from map: @{[sort keys%fontmissing]}\n" if %fontmissing;
  }
  # vvv can search for .pfb, .pfa and .enc
  my $found=qx{kpsewhich -- @{[map{shq$_}keys%searchfiles]} 2>/dev/null};
  while ($found=~m@^(.*?([^\n/\\]+))$@mg) {
    if (exists $searchfiles{$2}) {
      delete $searchfiles{$2};
      $fontfull{$2}=$1;
    } else { print STDERR "warning: unexpected font name: $1\n" }
  }
  print STDERR "warning: missing files: @{[sort keys%searchfiles]}\n" if %searchfiles;
  if (!$opt_fontembed) { for my $fontname (sort keys %fontnames2) {
    next if !exists $fontfull{$fontnames2{$fontname}};
    my $S=$fontfull{$fontnames2{$fontname}};
    if (exists $fontchanges{$fontname}) {
      die unless open F, "< $S";
      my $D="";
      1 while 0<read F, $D, 4096, length$D;
      die unless close F;
      # vvv Dat: `{restore}if' in lmodern fonts
      die unless $D=~s@\s+cleartomark\s*(\{\s*restore\s*}\s*if\s*)?(?:\x80[\003])?\s*\Z(?!\n)@"\ncleartomark".(defined$1?"{restore}if":"")@e;
      if ($D=~s@\A\x80[\001\002]....@@s) { # permissive convert PFB to PFA
        die unless $D=~s@\s+currentfile\s+eexec\s*\x80[\001\002]....@\ncurrentfile eexec\n@s;
	die unless $D=~s@\x80[\001\002]....[\r\n]*([0\r\n]+cleartomark(?:\{restore\}if)?)\Z(?!\n)@@s;
	my $E="\n$1"; $E=~s@\r\n?@\n@g;
	$D.=$E;
      }
      die unless $D=~s@\A(.*?)\s+currentfile\s+eexec\s@@s;
      my $head; $head="$1\ncurrentfile eexec\n";
      # Dat: don't convert eexec()ed data in $D to binary
      $head=~s@\r\n?@\n@g;
      die if $head!~m@/FontName\s+/([^/{}\[\]()\s]+)@;
      my $psfontname=$1;
      print STDERR "mpgsmap info: creating $fontprefix$fontname.gsf\n";
      die unless open F, "> $fontprefix$fontname.gsf";
      die unless print F "%% a modified Ghostscript Type1 font of TeX font $fontname\n$genmsg$t1_modifydict";
      for my $extrafile (@{$fontextrafiles{$fontname}}) {
        die unless open EF, "< $fontfull{$extrafile}"; # usually a /.../texmf/dvips/base/....enc
	while (1<read EF, $_, 4096) { die unless print F }
	die unless print F "\n";
	die unless close EF;
      }
      die unless print F "$head$D\n/$fontname {$fontchanges{$fontname}} /$psfontname changeFont end\n";
      die unless close F;
      $S=get_pwd()."/$fontprefix$fontname.gsf";
    }
    $S=~s@([^!-'*-~])@sprintf"\\%03o",ord$1@ge;
    # Imp: quote fontname??
    $fontname=$fontname2ps{$fontname} if defined $fontname2ps{$fontname};
    print FONTMAP "/$fontname ($S);\n";
    $C++;
  }}
} else { print STDERR "warning: no fonts found\n" }
print FONTMAP "%% __EOF__\n";
die unless close FONTMAP;
if ($C==0) { print STDERR "warning: no fonts in $Fontmap\n" }
elsif ($C==1) { print STDERR "mpgsmap info: listed 1 font to $Fontmap\n" }
else { print STDERR "mpgsmap info: listed $C fonts to $Fontmap\n" }
}

for my $fn (sort keys %fix_epss) { # Imp: numeric sort of extensions
  # Imp: make --fontembed idempotent
  #die $fix_epsfso{$fn};
  # Imp: also change `%!PS' to `%!PS-Adobe-3.0 EPSF-3.0'
  my $T=$fix_epss{$fn}; # Dat: $T will be /fshow definition
  print STDERR "mpgsmap info: adding about ".length($T)." bytes to: $fn\n";
  die unless open F, "+< $fn\n";
  my $L;
  if (defined $fix_epsfso{$fn}) { # remove original definition of /fshow 
    die unless seek F, $fix_epsfso{$fn}, 0;
    die unless 6==read F, $L, 6;
    die unless $L eq '/fshow';
    die unless seek F, $fix_epsfso{$fn}, 0;
    die unless print F '/----w'; # redefine something else
    die unless seek F, 0, 0;
  }
  my $do_fontembed=exists $fix_epsfembed{$fn};
  if ($do_fontembed) {
    $T="" if defined $fix_epsfso{$fn}; # EPS file already has /cmr10 /cmr10 def
    $T=~s@/fshow.*@@s;
    my $TT=$T; $T="save\n";
    my $jobname='mpgsmapF';
    unlink "$jobname.dvi", "$jobname.ps", "$jobname.log";
    die unless open PS, "> $jobname.dvi";
    die unless print PS dvifile($fn);
    die unless close PS;
    # Imp: run dvips(1) before opening? -- but what about overriding fshow
    die "$0: error running dvips(1) for: $fn\n".
      "  Please fix it and try again.\n" unless 0==run_dvips(@dvipsopts, $jobname);
    die unless open PS, "< $jobname.ps";
    my $app_p;
    while (<PS>) { last if /^%DVIPS/ }
    die "$0: missing \%DVIPS: $jobname.ps" if !defined;
    while (<PS>) { last if substr($_,0,11)eq'%%EndProlog'; $T.=$_ }
    # ^^^ Imp: don't store whole $T (all fonts) in memory
    die "$0: missing \%EndProlog: $jobname.ps" if !defined;
    die unless close PS;
    unlink "$jobname.dvi", "$jobname.ps", "$jobname.log";
    $T.="TeXDict begin\n";
  }
  my $S;
  $S.=$L while defined($L=<F>) and substr($L,0,1)eq'%';
  die "$0: missing end-of-DSC?!: $fn\n" if !defined $L;
  die unless seek F, -length($S)-length($L), 1;
  my $S0L=length($S);
  $S=~s@\s+\Z(?!\n)@\n@;
  $S.="%%EndProlog\n" if $S!~m@^%%EndProlog\b@m; # Dat: should not happend with MetaPost output
  if ($do_fontembed) { # make it idempotent
    $S=~s@^%[*]Font:.*\n@@gm;
    $S=~s@^%%DocumentFonts:.*\n(?:%%[+] )*@@gm;
    # Imp: include DocumentFonts emitted by dvips(1)
  }
  my $BBL="";
  my $BBP;
  $S=~s@^(%%(?:HiRes|Exact|)BoundingBox:.*\n)@$BBP||=pos$S;$BBL.=$1;""@gem;
  # Imp: calculate BoundingBox from Hires... and vice versa
  $BBP||=length$S; substr($S,$BBP,0)=$BBL;
  $T=$S.$T;
  $T=~s@\A(?:%!.*\n)?@\%!PS-Adobe-3.0 EPSF-3.0\n@;
  $T.="\n"x($S0L-length($T)) if $S0L>length$T;
  die unless print F substr($T, 0, $S0L);
  die "$0: output too short\n" if $do_fontembed and ($S0L<20 or $S0L>=length$T);
  if (length$T>$S0L) {
    $T=substr($T,$S0L); $S="";
    die unless tell F; # Dat: so we can intermix read & write
    while (1) {
      ##print STDERR "Xls=".length($S)."; ft=".tell(F)."\n";
      if (length$S>=length$T) {
	##print STDERR "ls=".length($S)."; ft=".tell(F)."\n";
	die "$!" unless seek F, -length($S), 1;
	die unless print F $T, substr($S,0,length($S)-length($T));
	die unless tell F; # Dat: so we can intermix read & write
	##print STDERR "ys=".length($S)."; ft=".tell(F)."\n";
	$T=length($S)==length($T) ? $S : substr($S,-length$T);
	$S="";
      }
      # Dat: assert(length($S)<length($T))
      my $N=read F, $S, (length$T<4096 ? 4096 : length$T)-length($S), length$S;
      die "$0: read from $fn: $!\n" if !defined $N; # read error
      ##print STDERR "N=$N\n";
      last if length $S<length $T;
    }
    die unless seek F, -length($S), 1;
    if ($do_fontembed) {
      die "$0: output end too short\n" if length($S)<20;
      die unless $S=~s@\s*(?:\%\%EOF\s*)\Z(?!\n)@\nend restore\n%%EOF\n@;
    }
    die unless print F $T, $S;
  }
  die unless close F;
}

__END__
